Subject: Re: AW: Trying to implement secondary loopback

From: [email-masked] (Eric W. Biederman)
Date: Wed, 13 Mar 2013 14:21:44 -0700

"Martitz, Thomas" <[email-masked]> writes:

>> Von: Eric W. Biederman [[email-masked]]
>>
>> The easy solution is to setup two network namespaces and two nics.
>> And transmit data from one network namespace to another, through your
>> nics.

>
> That sounds a lot more involed than using loopback to send data back
> to the same process. And I guess just calling netif_rx() in the xmit()
> function wouldn't be sufficient either? Also I wouldn't know how to do
> that as I'm not yet very familiar with network namespaces (but that
> can clearly get fixed).

It may sound involved but it is just a few lines of code to set up.

ip netns add ns1
ip netns add ns2
ip link set nic1 netns ns1
ip link set nic2 netns ns2

int main(int argc, char **argv)
{
        int netfd1, netfd2;
        int sk1, sk2;
	netfd1 = open(/var/run/netns/nic1);
	netfd2 = open(/var/run/netns/nic2);

	setns(netfd1, 0);
	sk1 = socket(...);

        setns(netfd2, 0);
        sk2 = socket(...);

        /* test test test */
}

And what is partidcularly interesting is that all of this works with
your drivers normal code paths without any kernel hacks.

Eric